extends KinematicBody2D

# 移動速度
const SPEED = 20000

# レイ
onready var ray = $Point/RayCast2D
# レイの親ノード
onready var ray_root = $Point

func _physics_process(delta: float) -> void:
	
	# 移動速度を計算する
	var vel = Vector2()
	vel.x = int(Input.is_action_pressed("ui_right")) - int(Input.is_action_pressed("ui_left"))
	vel.y = int(Input.is_action_pressed("ui_down")) - int(Input.is_action_pressed("ui_up"))

	vel = vel.normalized() * SPEED * delta
	
	# 移動実行
	move_and_slide(vel)
	
	if vel.length() > 0:
		# キーを入力した場合のみRayを回転する
		ray_root.rotation = vel.angle()
	
	if ray.is_colliding():
		# Rayに衝突しているオブジェクトが存在する
		# 衝突しているオブジェクトを取得する
		var col = ray.get_collider()
		if col.has_method("_on_interact"):
			# インタラクトメッセージがあれば呼び出す
			col._on_interact()
